/**
 * apeman react package for demo components
 * @class ApDemo
 */

'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _apeHighlighting = require('ape-highlighting');

var _apemanAssetStylesheets = require('apeman-asset-stylesheets');

var _apemanAssetStylesheets2 = _interopRequireDefault(_apemanAssetStylesheets);

var _apemanReactStyle = require('apeman-react-style');

var _apemanReactHtml = require('apeman-react-html');

var _apemanReactHead = require('apeman-react-head');

var _apemanReactBody = require('apeman-react-body');

var _apemanReactLinks = require('apeman-react-links');

var _apemanReactIcon = require('apeman-react-icon');

var _apemanReactSpinner = require('apeman-react-spinner');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var DEFAULT_FAVICON_URL = 'https://raw.githubusercontent.com/apeman-asset-labo/apeman-asset-images/master/dist/favicon/react-favicon.png';

/** @lends ApDemo */
var ApDemo = _react2.default.createClass({
  displayName: 'ApDemo',


  // --------------------
  // Specs
  // --------------------

  propTypes: {
    /** Package data */
    pkg: _react.PropTypes.object.isRequired,
    /** Source file path of demo target */
    src: _react.PropTypes.string.isRequired,
    /** Favicon URL */
    favicon: _react.PropTypes.string,
    /** Script file path */
    scripts: _react.PropTypes.array,
    /** Link URLs */
    links: _react.PropTypes.object,
    /** Additional head child node */
    head: _react.PropTypes.node,
    /** Additional body child node */
    body: _react.PropTypes.node
  },

  mixins: [],

  statics: {
    DEFAULT_FAVICON_URL: DEFAULT_FAVICON_URL
  },

  getInitialState: function getInitialState() {
    return {};
  },
  getDefaultProps: function getDefaultProps() {
    return {
      favicon: DEFAULT_FAVICON_URL,
      scripts: [],
      links: {},
      head: null,
      body: null
    };
  },
  render: function render() {
    var s = this;
    var state = s.state;
    var props = s.props;
    var pkg = props.pkg;
    var src = props.src;
    var favicon = props.favicon;
    var scripts = props.scripts;
    var links = props.links;
    var children = props.children;


    return _react2.default.createElement(
      _apemanReactHtml.ApHtml,
      { className: 'react-demo' },
      _react2.default.createElement(
        _apemanReactHead.ApHead,
        { charset: 'UTF-8',
          title: pkg.name + ' Demo',
          version: pkg.version,
          js: scripts,
          icon: favicon },
        _react2.default.createElement(_apemanReactStyle.ApStyle, { data: _fs2.default.readFileSync(_apemanAssetStylesheets2.default.reactDemo).toString() }),
        _react2.default.createElement(_apemanReactIcon.ApIconStyle, null),
        _react2.default.createElement('link', { rel: 'stylesheet', href: _apemanReactIcon.CdnConstants.FONT_AWESOME_CDN }),
        _react2.default.createElement('link', { rel: 'stylesheet', href: _apemanReactIcon.CdnConstants.ICON_ICONS_CDN }),
        _react2.default.createElement(_apemanReactSpinner.ApSpinnerStyle, null),
        props.head
      ),
      _react2.default.createElement(
        _apemanReactBody.ApBody,
        null,
        _react2.default.createElement('div', { id: 'demo-style' }),
        _react2.default.createElement(
          'header',
          { className: 'react-demo-header' },
          _react2.default.createElement(
            'div',
            { className: 'react-demo-container' },
            _react2.default.createElement(
              'h1',
              null,
              _react2.default.createElement(
                'a',
                { href: pkg.homepage },
                pkg.name
              )
            )
          )
        ),
        _react2.default.createElement(
          'main',
          null,
          _react2.default.createElement(
            'div',
            null,
            _react2.default.createElement(
              'div',
              { className: 'react-demo-playground' },
              _react2.default.createElement(
                'div',
                { className: 'react-demo-container' },
                _react2.default.createElement(
                  'div',
                  { id: 'demo-wrap' },
                  children
                )
              )
            )
          ),
          _react2.default.createElement(
            'div',
            { className: 'react-demo-container' },
            _react2.default.createElement(
              'div',
              null,
              _react2.default.createElement('pre', { className: 'react-demo-src', dangerouslySetInnerHTML: { __html: _apeHighlighting.highlightJsx.fromFile(src) } })
            )
          )
        ),
        _react2.default.createElement(
          'footer',
          null,
          _react2.default.createElement(
            'div',
            { className: 'react-demo-container' },
            _react2.default.createElement(_apemanReactLinks.ApLinks, { links: links })
          )
        ),
        props.body
      )
    );
  }

  // ------------------
  // Custom
  // ------------------

  // ------------------
  // Private
  // ------------------

});

exports.default = ApDemo;
//# sourceMappingURL=data:application/json;base64,bnVsbA==